#include <bits/stdc++.h>

using namespace std;

int n;
int k;
int cnt[1000005];
bool mark[2005][2005];
int gornjelevored;
int gornjelevokolona;
int donjedesnored;
int donjedesnokol;
int basta[2005][2005];
int por[]={0,0,1,-1};
int pok[]={1,-1,0,0};
int brkonacnih;

void pronadjiZonu()
{
    mark[gornjelevored][gornjelevokolona]=true;
    
    queue<pair<int,int>> polja;
    polja.push({gornjelevored,gornjelevokolona});
    
    int br=0;
    int el=basta[gornjelevored][gornjelevokolona];
    
    while(!polja.empty())
    {
        pair<int,int> temp=polja.front();
        polja.pop();
        int tempr=temp.first;
        int tempk=temp.second;
        donjedesnored=tempr;
        donjedesnokol=tempk;
        br++;
        
        for(int i=0;i<4;i++)
        {
            int nr=tempr+por[i];
            int nk=tempk+pok[i];
            
            if(nr>=1 && nr<=n && nk>=1 && nk<=n)
            {
                if(basta[nr][nk]==el && !mark[nr][nk])
                {
                    mark[nr][nk]=true;
                    polja.push({nr,nk});
                }
            }
        }
    }
    
    if(donjedesnored>=gornjelevored && donjedesnokol>=gornjelevokolona)
    {
        int stranica1=donjedesnored-gornjelevored+1;
        int stranica2=donjedesnokol-gornjelevokolona+1;
        int povrsina=stranica2*stranica1;
        
        if(br==cnt[el] && br==povrsina)
        {
            brkonacnih++;
        }
        
    }
    
}

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin >> n >> k;
    
    brkonacnih=0;
    
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> basta[i][j];
            cnt[basta[i][j]]++;
            mark[i][j]=false;
        }
    }
    
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(!mark[i][j])
            {
                gornjelevored=i;
                gornjelevokolona=j;
                pronadjiZonu();
            }
        }
    }
    
    cout << brkonacnih;
    
    return 0;
}